
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.applet;

import java.net.URL;
import java.net.MalformedURLException;
import java.awt.Panel;
import java.awt.Dimension;
import java.awt.Image;

public class Applet extends Panel
{
	private AppletStub stub;
	private AppletContext context;

	public AudioClip getAudioClip(URL url)
	{
		return context.getAudioClip(url);
	}

	public AudioClip getAudioClip(URL url, String name)
	{
		try
		{
			return getAudioClip(new URL(url, name));
		}
		catch (MalformedURLException e)
		{
			return null;
		}
	}

	public Image getImage(URL url)
	{
		return context.getImage(url);
	}

	public Image getImage(URL url, String name)
	{
		try
		{
			return getImage(new URL(url, name));
		}
		catch (MalformedURLException e)
		{
			return null;
		}
	}

	public void play(URL url)
	{
		getAudioClip(url).play();
	}

	public void play(URL url, String name)
	{
		getAudioClip(url, name).play();
	}

	public void showStatus(String string)
	{
		context.showStatus(string);
	}

	public URL getCodeBase()
	{
		return stub.getCodeBase();
	}

	public URL getDocumentBase()
	{
		return stub.getDocumentBase();
	}

	public AppletContext getAppletContext()
	{
		return context;
	}

	public String getParameter(String name)
	{
		return stub.getParameter(name);
	}

	public void resize(int width, int height)
	{
		stub.appletResize(width, height);
		super.resize(width, height);
	}

	public void resize(Dimension d)
	{
		resize(d.width, d.height);
	}

	public final void setStub(AppletStub stub)
	{
		this.stub = stub;
		context = stub.getAppletContext();
	}

	public boolean isActive()
	{
		return stub.isActive();
	}

	public String[][] getParameterInfo()
	{
		return null;
	}

	public String getAppletInfo()
	{
		return null;
	}

	public void init()
	{
	}

	public void start()
	{
	}

	public void stop()
	{
	}

	public void destroy()
	{
	}

	public Applet()
	{
	}
}

