
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

public abstract class FontMetrics
{
	protected Font font;

	public String toString()
	{
		return "FontMetrics:" + font;
	}

	public int charWidth(char c)
	{
		return 0;	// TODO: figure out what goes here
	}

	public int charWidth(int c)
	{
		return charWidth((char) c);
	}

	public int[] getWidths()
	{
		int[] widths = new int[0x100];
		for (int i = 0; i < widths.length; i++)
			widths[i] = charWidth(i);
		return widths;
	}

	public int charsWidth(char data[], int off, int len)
	{
		int width = 0;
		for (int i = 0; i < len; i++)
			width += charWidth(data[off + i]);
		return width;
	}

	public int bytesWidth(byte data[], int off, int len)
	{
		int width = 0;
		for (int i = 0; i < len; i++)
			width += charWidth((int) data[off + i]);
		return width;
	}

	public int stringWidth(String str)
	{
		int width = 0;
		int len = str.length();
		for (int i = 0; i < len; i++)
			width += charWidth(str.charAt(i));
		return width;
	}

	public int getMaxAdvance()
	{
		return -1;	// TODO: figure out what goes here
	}

	public int getAscent()
	{
		return 0;	// TODO: figure out what goes here
	}

	public int getDescent()
	{
		return 0;	// TODO: figure out what goes here
	}

	public int getLeading()
	{
		return 0;	// TODO: figure out what goes here
	}

	public int getHeight()
	{
		return getLeading() + getAscent() + getDescent();
	}

	public int getMaxAscent()
	{
		return 0;	// TODO: figure out what goes here
	}

	public int getMaxDescent()
	{
		return 0;	// TODO: figure out what goes here
	}

	public Font getFont()
	{
		return font;
	}

	protected FontMetrics(Font font)
	{
		this.font = font;
	}
}
