
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

public class GridBagConstraints implements Cloneable
{
	public final static int CENTER		= 10;
	public final static int NORTH		= 11;
	public final static int NORTHEAST	= 12;
	public final static int EAST		= 13;
	public final static int SOUTHEAST	= 14;
	public final static int SOUTH		= 15;
	public final static int SOUTHWEST	= 16;
	public final static int WEST		= 17;
	public final static int NORTHWEST	= 18;

	public final static int NONE		= 0;
	public final static int BOTH		= 1;
	public final static int HORIZONTAL	= 2;
	public final static int VERTICAL	= 3;

	public final static int REMAINDER	= 0;
	public final static int RELATIVE	= -1;

	public int anchor	= CENTER;
	public int fill		= NONE;
	public int gridheight	= 1;
	public int gridwidth	= 1;
	public int gridx	= RELATIVE;
	public int gridy	= RELATIVE;
	public int ipadx	= 0;
	public int ipady	= 0;
	public double weightx	= 0.0;
	public double weighty	= 0.0;
	public Insets insets	= new Insets(0, 0, 0, 0);

	public Object clone()
	{
		try
		{
			GridBagConstraints c = (GridBagConstraints) super.clone();
			c.insets = (Insets) c.insets.clone();
			return c;
		}
		catch (CloneNotSupportedException e)
		{
			return null;
		}
	}

	public GridBagConstraints()
	{
	}
}

