
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

import java.awt.peer.MenuBarPeer;

import java.util.Vector;

public class MenuBar extends MenuComponent implements MenuContainer
{
	private Vector menus = new Vector();
	private Menu helpMenu = null;

	public void addNotify()
	{
		Window window = (Window) this.getParent();
		Toolkit toolkit = window.getToolkit();

		peer = toolkit.createMenuBar(this);
	}

	public void removeNotify()
	{
		int n = countMenus();
		for (int i = 0; i < n; i++)
		{
			Menu menu = (Menu) menus.elementAt(i);
			menu.removeNotify();
		}
		if (peer != null)
			peer.dispose();
	}

	public Menu add(Menu menu)
	{
		menus.addElement(menu);
		if (peer != null)
			((MenuBarPeer) peer).addMenu(menu);
		return menu;
	}

	public void setHelpMenu(Menu menu)
	{
		helpMenu = menu;
		if (peer != null)
			((MenuBarPeer) peer).addHelpMenu(menu);
	}

	public void remove(int index)
	{
		menus.removeElementAt(index);
		if (peer != null)
			((MenuBarPeer) peer).delMenu(index);
	}

	public void remove(MenuComponent menu)
	{
		int n = menus.indexOf(menu);
		if (n >= 0)
			remove(n);
	}

	public int countMenus()
	{
		return menus.size();
	}

	public Menu getMenu(int i)
	{
		return (Menu) menus.elementAt(i);
	}

	public Menu getHelpMenu()
	{
		return helpMenu;
	}

	public MenuBar()
	{
	}
}

