
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

public class Point
{
	public int x;
	public int y;

	public String toString()
	{
		return "(" + x + ", " + y + ")";
	}

	public boolean equals(Object obj)
	{
		if (obj == null)
			return false;
		if (!(obj instanceof Point))
			return false;

		Point p = (Point) obj;

		return (p.x == x && p.y == y);
	}

	public int hashCode()
	{
		return x ^ y;
	}

	public void move(int x, int y)
	{
		this.x = x;
		this.y = y;
	}

	public void translate(int dx, int dy)
	{
		move(x + dx, y + dy);
	}

	public Point(int x, int y)
	{
		move(x, y);
	}
}

