
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

import java.awt.peer.WindowPeer;

public class Window extends Container
{
	public void addNotify()
	{
		peer = getToolkit().createWindow(this);
	}

	public void dispose()
	{
		if (peer != null)
			peer.dispose();
		peer = null;
	}

	public void pack()
	{
		resize(preferredSize());
	}

	public void show()
	{
		if (isVisible())
			toFront();
		else
			super.show();
	}

	public void toFront()
	{
		if (peer != null)
			((WindowPeer) peer).toFront();
	}

	public void toBack()
	{
		if (peer != null)
			((WindowPeer) peer).toBack();
	}

	public Toolkit getToolkit()
	{
		return Toolkit.getDefaultToolkit();
	}

	public final String getWarningString()
	{
		SecurityManager sm = System.getSecurityManager();
		if (sm == null)
			return null;
		if (sm.checkTopLevelWindow(this))
			return null;

		String string = System.getProperty("awt.appletWarning");

		return (string != null) ? string : "Warning: Applet Window";
	}

	public Window(Frame parent)
	{
		this.parent = parent;
		setLayout(new BorderLayout());
	}
}

