
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt.image;

public abstract class ColorModel
{
	private static ColorModel RGBdefault = new DirectColorModel(32, 0x00FF0000, 0x0000FF00, 0x000000FF, 0xFF000000);

	protected int pixel_bits;

	public static ColorModel getRGBdefault()
	{
		return RGBdefault;
	}

	public abstract int getRed(int pixel);
	public abstract int getBlue(int pixel);
	public abstract int getGreen(int pixel);
	public abstract int getAlpha(int pixel);

	public int getPixelSize()
	{
		return pixel_bits;
	}

	public int getRGB(int pixel)
	{
		return	(getAlpha(pixel) << 24) +
			(getRed(pixel)   << 16) +
			(getGreen(pixel) <<  8) +
			(getBlue(pixel)  <<  0);
	}

	public ColorModel(int bits)
	{
		pixel_bits = bits;
	}
}
