
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt.image;

import java.util.Hashtable;

public interface ImageConsumer
{
	public final static int IMAGEERROR		= 1;
	public final static int SINGLEFRAMEDONE		= 2;
	public final static int STATICIMAGEDONE		= 3;
	public final static int IMAGEABORTED		= 4;

	public final static int RANDOMPIXELORDER	= 1;
	public final static int TOPDOWNLEFTRIGHT	= 2;
	public final static int COMPLETESCANLINES	= 4;
	public final static int SINGLEPASS		= 8;
	public final static int SINGLEFRAME		= 16;

	public abstract void setColorModel(ColorModel model);
	public abstract void setDimensions(int width, int height);
	public abstract void setHints(int hintflags);
	public abstract void setPixels(int x, int y, int w, int h, ColorModel model, byte[] pixels, int off, int scansize);
	public abstract void setPixels(int x, int y, int w, int h, ColorModel model, int[] pixels, int off, int scansize);
	public abstract void setProperties(Hashtable props);
	public abstract void imageComplete(int status);
}

