
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt.image;

import java.util.Hashtable;

public class ImageFilter implements ImageConsumer, Cloneable
{
	protected ImageConsumer consumer;

	public Object clone()
	{
		try
		{
			return super.clone();
		}
		catch (CloneNotSupportedException e)
		{
			return null;
		}
	}

	public ImageFilter getFilterInstance(ImageConsumer ic)
	{
		ImageFilter instance = (ImageFilter) clone();
		instance.consumer = ic;
		return instance;
	}

	public void resendTopDownLeftRight(ImageProducer ip)
	{
		ip.requestTopDownLeftRightResend(this);
	}

	public void setColorModel(ColorModel model)
	{
		consumer.setColorModel(model);
	}

	public void setDimensions(int width, int height)
	{
		consumer.setDimensions(width, height);
	}

	public void setHints(int hints)
	{
		consumer.setHints(hints);
	}

	public void setPixels(int x, int y, int w, int h, ColorModel model, byte[] pixels, int off, int scanSize)
	{
		consumer.setPixels(x, y, w, h, model, pixels, off, scanSize);
	}

	public void setPixels(int x, int y, int w, int h, ColorModel model, int[] pixels, int off, int scanSize)
	{
		consumer.setPixels(x, y, w, h, model, pixels, off, scanSize);
	}

	public void setProperties(Hashtable props)
	{
		String filters = (String) props.get("filters");
		filters = ((filters == null) ? "" : filters) + ", " + toString();
		props.put("filters", filters);
		consumer.setProperties(props);
	}

	public void imageComplete(int status)
	{
		consumer.imageComplete(status);
	}

	public ImageFilter()
	{
	}
}

