
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt.peer;

import java.awt.Dimension;
import java.awt.Color;
import java.awt.Font;
import java.awt.Toolkit;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Event;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;

import java.awt.image.ColorModel;
import java.awt.image.ImageProducer;
import java.awt.image.ImageObserver;

public interface ComponentPeer
{
	public abstract void enable();
	public abstract void disable();
	public abstract void show();
	public abstract void hide();
	public abstract void dispose();
	public abstract Dimension minimumSize();
	public abstract Dimension preferredSize();
	public abstract void reshape(int x, int y, int width, int height);
	public abstract void setForeground(Color c);
	public abstract void setBackground(Color c);
	public abstract void setFont(Font f);
	public abstract Graphics getGraphics();
	public abstract Toolkit getToolkit();
	public abstract ColorModel getColorModel();
	public abstract FontMetrics getFontMetrics(Font font);
	public abstract void requestFocus();
	public abstract void nextFocus();
	public abstract Image createImage(ImageProducer producer);
	public abstract Image createImage(int width, int height);
	public abstract boolean prepareImage(Image image, int width, int height, ImageObserver observer);
	public abstract int checkImage(Image image, int width, int height, ImageObserver observer);
	public abstract boolean handleEvent(Event e);
	public abstract void paint(Graphics g);
	public abstract void print(Graphics g);
	public abstract void repaint(long millis, int x, int y, int width, int height);
}

