
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.io;

public class FilterOutputStream
{ 
	protected OutputStream out;

	public synchronized void close() throws IOException
	{
		flush();
		out.close();
	}

	public void flush() throws IOException
	{
		out.flush();
	}

	public void write(int b) throws IOException
	{
		out.write(b);
	}

	public synchronized void write(byte[] b, int off, int len) throws IOException
	{
		out.write(b, off, len);
	}

	public void write(byte[] b) throws IOException
	{
		out.write(b);
	}

	public FilterOutputStream(OutputStream out)
	{
		this.out = out;
	}
}

