
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.io;

public class PipedOutputStream extends OutputStream
{
	private PipedInputStream sink;

	public synchronized void close() throws IOException
	{
		if (sink == null)
			throw new IOException();
		sink.close();
	}

	public synchronized void connect(PipedInputStream sink) throws IOException
	{
		if (sink != null)
			throw new IOException();
		this.sink = sink;
	}

	public synchronized void write(int b) throws IOException
	{
		if (sink == null)
			throw new IOException();
		sink.write(b);
	}

	public synchronized void write(byte[] b, int off, int len) throws IOException
	{
		if (sink == null)
			throw new IOException();
		for (int i = off; i < off + len; i++)
			sink.write((int) b[i]);
	}

	public PipedOutputStream(PipedInputStream sink) throws IOException
	{
		connect(sink);
	}

	public PipedOutputStream()
	{
	}
}

