/*
 *  java.lang.Object
 *
 *  (c) 1997 George David Morrison
 *
 *  API version: 1.0.2
 *
 *  History:
 *  01FEB1997  George David Morrison
 *    Initial version
 */

package java.lang;

public class Object
{
	public native final Class getClass();
	public native final void notify() throws IllegalMonitorStateException;
	public native final void notifyAll() throws IllegalMonitorStateException;
	public native final void wait(long millis, int nanos) throws IllegalMonitorStateException, InterruptedException;
	public native int hashCode();
	protected native Object clone() throws CloneNotSupportedException;

	public String toString()
	{
		return getClass().getName() + '@' + Integer.toHexString(hashCode());
	}

	public boolean equals(Object obj)
	{
		return (this == obj);
	}

	public final void wait(long millis) throws IllegalMonitorStateException, InterruptedException
	{
		wait(millis, 0);
	}

	public final void wait() throws IllegalMonitorStateException, InterruptedException
	{
		wait(Long.MAX_VALUE, 0);	// ~ 300 Million Years
	}

	protected void finalize() throws Throwable
	{
	}

	public Object()
	{
	}
}

