/*
 *  java.lang.Throwable
 *
 *  (c) 1997 George David Morrison
 *
 *  API version: 1.0.2
 *
 *  History:
 *  01FEB1997  George David Morrison
 *    Initial version
 */

package java.lang;

import java.lang.NativeLang;

import java.io.PrintStream;

public class Throwable
{
	private Object[] backtrace;
	private String detailMessage;

	public String toString()
	{
		return getClass().getName() + ": " + detailMessage;
	}

	public String getMessage()
	{
		return detailMessage;
	}

	public Throwable fillInStackTrace()
	{
		backtrace = NativeLang.getStackTrace();
		return this;
	}

	public void printStackTrace()
	{
		printStackTrace(System.err);
	}

	public void printStackTrace(PrintStream s)
	{
		s.println(this);
		for (int i = 0; i < backtrace.length; i++)
			if (backtrace[i] instanceof char[])
				s.println((char[]) backtrace[i]);
			else
				s.println(backtrace[i]);
	}

	public Throwable(String message)
	{
		detailMessage = message;
		fillInStackTrace();
	}

	public Throwable()
	{
		this("");
	}
}

