
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.net;

import java.net.NativeNet;

import java.io.IOException;
import java.io.FileDescriptor;

public class DatagramSocket
{ 
	FileDescriptor fd;
	int port = 0;

	protected void finalize()
	{
		if (fd != null)
			close();
	}

	public synchronized void close()
	{
		try
		{
			NativeNet.close(fd);
		}
		catch (IOException e)
		{
		}

		fd = null;
	}

	public void receive(DatagramPacket p) throws IOException
	{
		int[] other = new int[2];
		NativeNet.recv(fd, p.buff, p.addr.addr, other);
		p.length = other[0];
		p.port = other[2];
	}

	public void send(DatagramPacket p) throws IOException
	{
		NativeNet.send(fd, p.buff, p.length, p.addr.addr, p.port);
	}

	public int getLocalPort()
	{
		return port;
	}

	public DatagramSocket(int port) throws SocketException
	{
                NativeNet.dgsocket(/*out*/fd);
                byte[] inaddr_any = {-1,-1,-1,-1};
                try
                {
                        NativeNet.bind(fd, inaddr_any, port);
                        this.port = port;
                }
                catch (IOException e)
                {
                        throw new SocketException(e.getMessage());
                }
	}

	public DatagramSocket() throws SocketException
	{
		this(0);
	}
}

