
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.net;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileDescriptor;

import java.net.NativeNet;

/* NOT public */ final class DefaultSocketImpl extends SocketImpl
{ 
	private InputStream in;
	private OutputStream out;

	public void create(boolean stream) throws IOException
	{
		NativeNet.socket(/*out*/fd, stream);
	}

	public void bind(InetAddress host, int port) throws IOException
	{
		NativeNet.bind(fd, host.getAddress(), port);
	}

	public void listen(int count) throws IOException
	{
		NativeNet.listen(fd, count);
	}

	public void accept(SocketImpl s) throws IOException
	{
		Object[] results = new Object[3];

		NativeNet.accept(fd, results);

		s.fd = (FileDescriptor) results[0];
		s.address = new InetAddress((byte[]) results[1]);
		s.port = ((int[]) results[2])[0];
		s.localport = localport;
	}

	public int available() throws IOException
	{
		return NativeNet.available(fd);
	}

	public void close() throws IOException
	{
		NativeNet.close(fd);
	}

	public void connect(InetAddress address, int port) throws IOException
	{
		NativeNet.connect(fd, address.getAddress(), port);
		this.address = address;
		this.port = port;
		in = new FileInputStream(fd);
		out = new FileOutputStream(fd);
	}

	public void connect(String host, int port) throws IOException
	{
		InetAddress addr = InetAddress.getByName(host);
		connect(addr, port);
	}

	public InputStream getInputStream() throws IOException
	{
		return in;
	}

	public OutputStream getOutputStream() throws IOException
	{
		return out;
	}

	public DefaultSocketImpl()
	{
	}
}

