
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.net;

import java.io.IOException;

public final class ServerSocket
{ 
	private static SocketImplFactory factory;

	public static void setSocketImplFactory(SocketImplFactory fac) throws IOException
	{
		if (factory != null)
			throw new SocketException();
		factory = fac;
	}

	SocketImpl impl;

	public String toString()
	{
		return super.toString();
	}

	public Socket accept() throws IOException
	{
		Socket skt = new Socket();
		impl.accept(skt.impl);
		return skt;
	}

	public void close() throws IOException
	{
		impl.close();
	}

	public InetAddress getInetAddress()
	{
		return impl.getInetAddress();
	}

	public int getLocalPort()
	{
		return impl.getLocalPort();
	}

	public ServerSocket(int port, int count) throws IOException
	{
		if (factory != null)
			impl = factory.createSocketImpl();
		else
			impl = new DefaultSocketImpl();

		impl.create(true);
		impl.bind(InetAddress.INADDR_ANY, port);
		impl.listen(count);
	}

	public ServerSocket(int port) throws IOException
	{
		this(port, 50);
	}
}

