
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.net;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.FileDescriptor;

public abstract class SocketImpl
{ 
	protected InetAddress address;
	protected FileDescriptor fd;
	protected int localport;
	protected int port;

	public String toString()
	{
		return super.toString();
	}

	protected FileDescriptor getFileDescriptor()
	{
		return fd;
	}

	protected InetAddress getInetAddress()
	{
		return address;
	}

	protected int getLocalPort()
	{
		return localport;
	}

	protected int getPort()
	{
		return port;
	}

	protected abstract void create(boolean stream) throws IOException;
	protected abstract void bind(InetAddress host, int port) throws IOException;
	protected abstract void listen(int count) throws IOException;
	protected abstract void accept(SocketImpl s) throws IOException;
	protected abstract void connect(InetAddress address, int port) throws IOException;
	protected abstract void connect(String host, int port) throws IOException;
	protected abstract int available() throws IOException;
	protected abstract void close() throws IOException;
	protected abstract InputStream getInputStream() throws IOException;
	protected abstract OutputStream getOutputStream() throws IOException;

	public SocketImpl()
	{
	}
}

