
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.net;

import java.io.IOException;

public abstract class URLStreamHandler
{ 
	protected abstract URLConnection openConnection(URL u) throws IOException;

	protected void parseURL(URL u, String spec, int start, int limit)
	{
		if (spec.indexOf("//", start) != start)
			return;

		spec = spec.substring(start + 2, limit);

		int colon = spec.indexOf(':');
		int slash = spec.indexOf('/');

		if (slash < 0)
			return;

		if (colon > 0 && colon < slash)
		{
			u.host = spec.substring(0, colon);
			String port = spec.substring(colon + 1, slash);
			u.port = Integer.parseInt(port);
		}
		else
		{
			u.host = spec.substring(0, slash);
			u.port = 80;
		}

		u.file = spec.substring(slash);
	}

	protected void setURL(URL u, String protocol, String host, int port, String file, String ref)
	{
		u.protocol = protocol;
		u.host = host;
		u.port = port;
		u.file = file;
		u.ref = ref;
	}

	protected String toExternalForm(URL u)
	{
		return	((u.protocol != null)	? (u.protocol + ":")	: "") +
			((u.host != null)	? ("//" + u.host)	: "")  +
			((u.port != -1)		? (":" + u.port)	: "") +
			((u.file != null)	? u.file		: "/") +
			((u.ref != null)	? ("#" + u.ref)		: "");
	}

	public URLStreamHandler()
	{
	}
}

