
// (C) 1996 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.util;

public class Observable extends Object
{ 
	// Variables

	private Vector observers;
	private boolean changed;
 
	// Protected Methods

	protected void clearChanged()
	{
		changed = false;
	}

	protected void setChanged()
	{
		changed = true;
	}

	// Public Methods

	public boolean hasChanged()
	{
		return changed;
	}

	public void addObserver(Observer o)
	{
		observers.addElement(o);
	}

	public void deleteObserver(Observer o)
	{
		observers.removeElement(o);
	}

	public void deleteObservers()
	{
		observers.removeAllElements();
	}

	public int countObservers()
	{
		return observers.size();
	}

	public void notifyObservers(Object arg)
	{
		Enumeration e = observers.elements();
		while (e.hasMoreElements())
			((Observer) e.nextElement()).update(this, arg);
		clearChanged();
	}

	public void notifyObservers()
	{
		notifyObservers(null);
	}

	// Constructors 

	public Observable()
	{
		changed = false;
		observers = new Vector();
	}
}

