/*
 * PropTest.java
 *
 * Test for system provided properties and command line provided properties.
 */
class PropTest {
	public static void checkProp(String propname)
	{
		String val = (String)System.getProperty(propname, "UNDEFINED PROPERTY");

		if (val.equals("UNDEFINED PROPERTY"))
			System.out.println("PROPERTY " +propname+ " is not defined.");
		else
			System.out.println("  " +propname+ "=`" +val+ "'");
	}

	public static void main (String args[]) {
		// Test default arg
		System.out.println("Should be 'FooBarBang': "+
				   System.getProperty("the.nonexistant.PrOpErTy", "FooBarBang"));

		// Test system defined properties
		checkProp("java.home");
		checkProp("file.separator");
		checkProp("file.-separator");
		checkProp("path.separator");
		checkProp("path.-separator");
		checkProp("line.separator");
		checkProp("file.encoding.pkg");
		checkProp("java.version");
		checkProp("java.vendor");
		checkProp("java.vendor.url");
		checkProp("java.class.version");
		checkProp("java.home");
		checkProp("java.class.path");
		checkProp("os.name");
		checkProp("os.arch");
		checkProp("os.version");
		checkProp("user.dir");
		checkProp("user.name");
		checkProp("user.home");
		checkProp("awt.toolkit");
		checkProp("java.resources");

		// Try defining these on the command line:
		checkProp("prop1");
		checkProp("prop2");
	}
}
