/*
 * StrAppend.java
 */
class StringTest {

	public static void main (String args[]) 
	{
		appendTest();
		equalsTest();
		substrTest();
		replaceTest();
		// insertTest();
		constructorTest();
	}

	static void error (String arg)
	{
		System.out.println("ERROR: " + arg);
		System.exit(11);
	}

	static void msg (String msg)
	{
		System.out.println(msg);
	}
	
	static void equalsTest()
	{
		String str1 = new String("This is a string.");
		String str2 = new String("This is a string.");

		if (str1 == str2)
			error("Whoa Nelly!  Something is really wrong; str1 == str2?  I think not.");
		
		if (!str1.equals(str2))
			error("says str1.equals(str2) is false, but its not.");

		msg("equalsTest() passed");
	}

	static void replaceTest()
	{
		String orig = new String("/this/is/the/original/string/");
		String expect = new String(" this is the original string ");
		String repl = orig.replace('/',' ');
		
		if (!(repl.equals(expect)))
			error("Expected: \'" +expect+ "\', got: \'" +repl+ "\'");

		orig = new String("??a ?? / /./. /? bbettttt??ee?e?rrr te?s?t?c?a?s?e?????");
		expect = new String("&&a && / /./. /& bbettttt&&ee&e&rrr te&s&t&c&a&s&e&&&&&");
		repl = orig.replace('?','&');

		if (!(repl.equals(expect)))
			error("Expected: \'" +expect+ "\', got: \'" +repl+ "\'");

		orig = new String("will not change at all in any way, no how, no sir.  Unless its broken");
		repl = orig.replace('!','#');
		if (!repl.equals(orig))
			error("Expected: \'" +orig+ "\'(unchanged from orig), got: \'" +repl+ "\'");

		msg("replaceTest() passed");
	}

	static void substrTest()
	{
		String str1 = new String("01234567890123456789"); // 20 chars, 0-19
		String sub1 = new String          ("0123456789"); // sub-string 1
		String sub2 = new String     ("5678901234");      // sub-string 2
		
		if (str1.length() != 20)
			error("substrTest: length is not 20.");
		
		String str2 = str1.substring(10);
		if (!str2.equals(sub1))
			error("substrTest: substring at position 10 is not \'" +sub1+ "\' but is instead \'" +str2+ "\'");
		
		str2 = str1.substring(5,15);
		if (!str2.equals(sub2))
			error("substrTest: substring at positions 5 through 15 is not \'" +sub2+ "\' but is instead \'" +str2+ "\'");

		msg("substrTest() passed");
	}

	static void appendPrint(String arg1, String arg2) 
	{
		System.out.println(arg1 + arg2);
	}

	static void appendTest()
	{
		appendPrint("Hello!", "");
		appendPrint("Hello ", "World!");
		appendPrint("", "Hello!");
		appendPrint("null+", null);  // == "null+null"
		appendPrint(null, "+null");  // == "null+null"

		msg("appendTest() passed");
	}

	static void checkString(String str, int expectedLen, char expectedChar0)
	{
	}

	static void constructorTest()
	{
		// ---
		String nullConstructor = new String();
		checkString(nullConstructor, 0, 'x');

		// ---
		char[] chararray = new char[10];
		chararray[0] = 'h';
		chararray[1] = 'e';
		chararray[2] = 'l';
		chararray[3] = 'l';
		chararray[4] = 'o';
		chararray[5] = ' ';

		String fromChar = new String(chararray);
		checkString(fromChar, 6, 'h');

		// ---
		String fromChar2 = new String(chararray, 2, 4);
		checkString(fromChar2, 4, 'l');

		// ---
		String orig = new String("Hello World");
		
		
	}
}

