/*
 * Burford.java
 *
 * Derived from the burford.java test distribued with Kaffe.
 */
public class Burford 
	implements Runnable 
{
	private Object v_mutex = new Object();
	private int v_counter = 0;

	public static void main(String argv[])
	{
		Burford b = new Burford();
		Thread bt = new Thread(b);
		
		System.out.println("Starting Burford...");
		
		bt.start();
		
		Thread f1 = new Thread(b.new Burford_Feeder(b));
		Thread f2 = new Thread(b.new Burford_Feeder(b));
		
		System.out.println("Starting feeders...");
		
		f1.start();
		f2.start();
		
		try 
		{
			f1.join();
			f2.join();
		} 
		catch (InterruptedException exc) 
		{
			// do nothing
		}
		
		System.out.println("Feeders completed...");
        
		b.awaken();

		System.out.println("Burford awakened -- result = " + b.counter());
		System.exit(0);
	}

	public void run()
	{
		try 
		{
			synchronized (v_mutex) 
			{
				v_mutex.wait();
			}
		} 
		catch (InterruptedException exc) 
		{
			// do nothing
		}
	}
	
	public synchronized int counter()
	{
		return (v_counter);
	}
	
	public synchronized void increment()
	{
		v_counter++;
	}
	
	public void awaken()
	{
		synchronized (v_mutex) 
		{
			v_mutex.notify();
		}
	}
	
	class Burford_Feeder implements Runnable 
	{
		private Burford v_target;

		Burford_Feeder(Burford target)
		{
			v_target = target;
		}
		
		public void run()
		{
			for (int i = 0; i < 50; i++) {
				v_target.increment();
			}
		}
		
	}
}
