/*
 * InfiniteThreads.java
 *
 * This is based on test T16 distributed with Kaffe.
 */

public class InfiniteThreads
	implements Runnable
{
	static final int MAX_THREADS = 5000;
	static final int PRINT_EVERY = 50;

	public static void main(String args[])
	{
		InfiniteThreads inst = new InfiniteThreads();

		System.out.println("Spawning " +MAX_THREADS+ " threads; printing every " +PRINT_EVERY+ "th.");

		inst.spawnThreads();
		
		System.out.println("SUCCESS");
	}
	
	public void spawnThreads()
	{
		int i = 0;
		
		while (i < MAX_THREADS)
		{
			Thread t = new Thread(this, ((i%PRINT_EVERY)==0)? "" +i  : "X" +i);

			t.start();

			try
			{
				t.join();
			}  
			catch(Exception e)
			{
				System.out.println("FAILURE: Thread join interrupted??");
				System.exit(11);
			}
			
			i++;
		}
	}

	public void run()
	{
		String name = Thread.currentThread().getName();

		if (name.charAt(0) != 'X')
			System.out.println("Got to thread " +name);
		
		// try { Thread.sleep(20); } catch (Exception e) /*NOP */ 
	}
}
