
class SynchTest_Obj
{
	int gotIt_;

	SynchTest_Obj()
	{
		gotIt_ = 0;
	}

	void error(String err)
	{
		System.out.println("Error: " +err);
	}

	public synchronized void acquire()
	{
		// While someone else has it
		while (gotIt_ != 0)
		{
			try 
			{
				wait();
			}
			catch (InterruptedException ie)
			{
				System.out.println("Thread: " +Thread.currentThread().toString()+
						   " woken in wait(): " +ie);
			}
		}

		
		if (gotIt_ != 0)
		{
			error("acquire: gotIt_ != 0; gotIt_ == "+gotIt_);
		}

		gotIt_++;
		
		if (gotIt_ != 1)
		{
			error("acquire: gotIt_ != 1; gotIt_ == "+gotIt_);
		}
	}

	public synchronized void release()
	{
		if (gotIt_ != 1)
		{
			error("release: gotIt_ != 1; gotIt_ == "+gotIt_);
		}

		gotIt_--;

		if (gotIt_ != 0)
		{
			error("release: gotIt_ != 0; gotIt_ == " +gotIt_);
		}
		notify();
	}
}

class SynchTest_Thread
	extends Thread
{
	SynchTest_Obj l_;

	SynchTest_Thread(SynchTest_Obj l)
	{
		l_ = l;
	}

	public void run()
	{
		while(true)
		{
			l_.acquire();
			l_.release();
		}
	}
}

class SynchTest
{
	public static void main(String[] argv)
	{
		SynchTest_Obj l = new SynchTest_Obj();
		
		int i;
		
		for (i=0; i<20; i++)
		{
			SynchTest_Thread th = new SynchTest_Thread(l);
			th.start();
		}
	}
}
