/*
 * HashTest.java
 *
 * 
 */
import java.util.Hashtable;

class HashTest {
	public static void error (String arg)
	{
		System.out.println("ERROR: " + arg);
		System.exit(11);
	}

	public static void TestTable(Hashtable tab, String name)
	{
		if (!tab.isEmpty())
			error(name + " starts off non-empty!");

		Object key1 = new Object();
		Object key2 = new Object();
		String val1 = "value 1";
		String val2 = "value 2";
		
		tab.put(key1, val1);
		tab.put(key2, val2);
		if (tab.put(key1, val1) != val1)
			error(name + "reinsert key1 doesn't return val1");

		if (tab.get(key2) != val2)
			error(name + "get(key2) != val2");

		if (tab.get(key2) != val2)
			error(name + "subsequent get(key2) != val2");

		if (!tab.contains(val1))
			error(name + "doesn't think it contains val1, when I know it damn well does!");

		if (!tab.contains(val2))
			error(name + "doesn't think it contains val2, when I know it damn well does!");

		String propKey1 = "java.home";
		String propVal1 = "/home/luser/java/";
		String propKey2 = "file.separator";
		String propVal2 = "/";

		tab.put(propKey1, propVal1);
		tab.put(propKey2, propVal2);

		// Test for same string, different instance (i.e. if it uses String.equals())
		if (tab.get(new String("file.separator")) != propVal2)
			error(name + "keys are not compared with .equals() in get() method");
		
		if (!tab.contains(new String("/home/luser/java/")))
			error(name + "values are not compared with .equals() in contains() method");

		if (!tab.containsKey(new String("java.home")))
			error(name + "values are not compared with .equals() in containsKey() method");


		// Lets see if null is valid is a key or what
		String nullVal = "Null Value";
		String nullKey = "Key for Null Val";

		try {
			tab.put(null, nullVal);

			error(name+ " can put a null key into hashtable");
		} catch(NullPointerException e) {
			// expected this
		}
		
		try {
			Object obj = tab.get(null);

			error(name+ " can get a null key from hashtable");
		} catch(NullPointerException e) {
			// expected this
		}
		
		try {
			tab.put(nullKey, null);

			error(name+ " can put a null value into hashtable");
		} catch(NullPointerException e) {
			// expected this
		}
		

	}

	public static void main (String args[]) {
		Hashtable htab1 = new Hashtable();
		Hashtable htab2 = new Hashtable(64);
		Hashtable htab3 = new Hashtable(64, 0.5f);

		TestTable(htab1, "htab1");
		TestTable(htab2, "htab2");
		TestTable(htab3, "htab3");

		System.out.println("Seems like things is okay...");
	}
}
