
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

import java.awt.peer.CheckboxPeer;

public class Checkbox extends Component
{
	private String label;
	private boolean state = false;
	private CheckboxGroup group;

	protected String paramString()
	{
		return	super.paramString()
			+ ", label=" + label
			+ ", state=" + state
			+ ((group != null) ? ", group=" + group : "");
	}

	public void addNotify()
	{
		peer = getToolkit().createCheckbox(this);
	}

	public void setLabel(String label)
	{
		this.label = label;
		if (peer != null)
			((CheckboxPeer) peer).setLabel(label);
	}

	public void setState(boolean state)
	{
		this.state = state;
		if (peer != null)
			((CheckboxPeer) peer).setState(state);
		if (group != null)
			group.setCurrent(this);
	}

	public void setCheckboxGroup(CheckboxGroup group)
	{
		this.group = group;
		if (peer != null)
			((CheckboxPeer) peer).setCheckboxGroup(group);
	}

	public String getLabel()
	{
		return label;
	}

	public boolean getState()
	{
		return state;
	}

	public CheckboxGroup getCheckboxGroup()
	{
		return group;
	}

	public Checkbox(String label, CheckboxGroup group, boolean state)
	{
		this.label = label;
		this.group = group;
		this.state = state;
	}

	public Checkbox(String label)
	{
		this(label, null, false);
	}

	public Checkbox()
	{
		this(null, null, false);
	}
}
