
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

import java.awt.peer.CheckboxMenuItemPeer;

public class CheckboxMenuItem extends MenuItem
{
	private boolean state = false;

	public String paramString()
	{
		return super.paramString() + ", state=" + state;
	}

	public void addNotify()
	{
		Menu menu = (Menu) this.getParent();
		MenuBar menubar = (MenuBar) menu.getParent();
		Window window = (Window) menubar.getParent();
		Toolkit toolkit = window.getToolkit();

		peer = toolkit.createCheckboxMenuItem(this);
	}

	public void setState(boolean state)
	{
		this.state = state;
		if (peer != null)
			((CheckboxMenuItemPeer) peer).setState(state);
	}

	public boolean getState()
	{
		return state;
	}

	public CheckboxMenuItem(String label)
	{
		super(label);
	}
}

