
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

import java.awt.peer.ChoicePeer;

import java.util.Vector;
import java.util.Enumeration;

public class Choice extends Component
{
	private Vector items = new Vector();
	private int selection = -1;

	protected String paramString()
	{
		StringBuffer buff = new StringBuffer();
		buff.append(super.paramString());
		buff.append(", items={");

		Enumeration e = items.elements();
		while (e.hasMoreElements())
		{
			String item = (String) e.nextElement();
			buff.append(item);
			if (e.hasMoreElements())
				buff.append(", ");
		}

		buff.append("}");

		if (selection >= 0)
			buff.append(", select=" + selection);

		return buff.toString();
	}

	public void addNotify()
	{
		peer = getToolkit().createChoice(this);
	}

	public void addItem(String item)
	{
		items.addElement(item);
		if (peer != null)
			((ChoicePeer) peer).addItem(item, items.size());
		if (items.size() == 1)
			select(0);
	}

	public int countItems()
	{
		return items.size();
	}

	public String getItem(int index)
	{
		return (String) items.elementAt(index);
	}

	public int getSelectedIndex()
	{
		return selection;
	}

	public String getSelectedItem()
	{
		return getItem(selection);
	}

	public void select(int index)
	{
		selection = index;
		if (peer != null)
			((ChoicePeer) peer).select(index);
	}

	public void select(String str)
	{
		int n = items.size();
		for (int i = 0; i < n; i++)
			if (str.equals(items.elementAt(i)))
				select(i);
	}

	public Choice()
	{
	}
}
