
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

import java.awt.peer.DialogPeer;

public class Dialog extends Window
{
	private String title;
	private boolean modal;
	private boolean resizable = true;

	protected String paramString()
	{
		return	super.paramString() +
			", title=" + title +
			(resizable ? ", resizable" : "") +
			(modal ? ", modal" : "");
	}

	public void addNotify()
	{
		peer = getToolkit().createDialog(this);
	}

	public void setTitle(String title)
	{
		this.title = title;
		if (peer != null)
			((DialogPeer) peer).setTitle(title);
	}

	public void setResizable(boolean resizable)
	{
		this.resizable = resizable;
		if (peer != null)
			((DialogPeer) peer).setResizable(resizable);
	}

	public String getTitle()
	{
		return title;
	}

	public boolean isResizable()
	{
		return resizable;
	}

	public boolean isModal()
	{
		return modal;
	}

	public Dialog(Frame parent, String title, boolean modal)
	{
		super(parent);
		this.title = title;
		this.modal = modal;
	}

	public Dialog(Frame parent, boolean modal)
	{
		this(parent, null, modal);
	}
}

