
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

import java.awt.peer.FileDialogPeer;

import java.io.FilenameFilter;

public class FileDialog extends Dialog
{
	public final static int LOAD = 0;
	public final static int SAVE = 1;

	private String directory;
	private String file;
	private FilenameFilter filter;
	private int mode;

	protected String paramString()
	{
		return	super.paramString() +
			", mode=" + mode +
			", dir=" + directory +
			", file=" + file +
			", filter=" + filter;
	}

	public void addNotify()
	{
		peer = getToolkit().createFileDialog(this);
	}

	public void setDirectory(String dir)
	{
		this.directory = directory;
		((FileDialogPeer) peer).setDirectory(directory);
	}

	public void setFile(String file)
	{
		this.file = file;
	}

	public void setFilenameFilter(FilenameFilter filter)
	{
		this.filter = filter;
	}

	public String getDirectory()
	{
		return directory;
	}

	public String getFile()
	{
		return file;
	}

	public FilenameFilter getFilenameFilter()
	{
		return filter;
	}

	public int getMode()
	{
		return mode;
	}

	public FileDialog(Frame parent, String title, int mode)
	{
		super(parent, title, true);
		this.mode = mode;
	}

	public FileDialog(Frame parent, String title)
	{
		this(parent, title, LOAD);
	}
}
