
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

import java.awt.peer.LabelPeer;

public class Label extends Component
{
	public final static int LEFT	= 0;
	public final static int CENTER	= 1;
	public final static int RIGHT	= 2;

	private String label;
	private int alignment;

	protected String paramString()
	{
		return	super.paramString() +
			", label=" + label +
			", alignment=" + alignment;
	}

	public void addNotify()
	{
		peer = getToolkit().createLabel(this);
	}

	public void setText(String label)
	{
		this.label = label;
		if (peer != null)
			((Label) peer).setText(label);
	}

	public void setAlignment(int alignment)
	{
		this.alignment = alignment;
		if (peer != null)
			((Label) peer).setAlignment(alignment);
	}

	public String getText()
	{
		return label;
	}

	public int getAlignment()
	{
		return alignment;
	}

	public Label(String label, int alignment)
	{
		this.label = label;
		this.alignment = alignment;
	}

	public Label(String label)
	{
		this(label, LEFT);
	}

	public Label()
	{
		this(null, LEFT);
	}
}

