
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

import java.awt.peer.MenuComponentPeer;

public abstract class MenuComponent
{
	protected MenuComponentPeer peer;
	protected MenuContainer parent;
	protected Font font;

	protected String paramString()
	{
		return "font=" + font;
	}

	public String toString()
	{
		return super.toString();
	}

	public void removeNotify()
	{
		if (peer != null)
			peer.dispose();
		peer = null;
	}

	public void setFont(Font font)
	{
		this.font = font;
	}

	public Font getFont()
	{
		return	(font != null)
			? font
			: (parent != null)
			  ? parent.getFont()
			  : null;
	}

	public MenuContainer getParent()
	{
		return parent;
	}

	public MenuComponentPeer getPeer()
	{
		return peer;
	}

	public boolean postEvent(Event e)
	{
		return (parent != null) && parent.postEvent(e);
	}

	public MenuComponent()
	{
	}
}

