
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

import java.awt.peer.MenuItemPeer;

public class MenuItem extends MenuComponent
{
	private String label;
	private boolean enabled = true;

	public String paramString()
	{
		return	super.paramString()
			+ ", label=" + label
			+ ", enabled=" + enabled;
	}

	public void addNotify()
	{
		Menu menu = (Menu) this.getParent();
		MenuBar menubar = (MenuBar) menu.getParent();
		Window window = (Window) menubar.getParent();
		Toolkit toolkit = window.getToolkit();

		peer = toolkit.createMenuItem(this);
	}

	public void setLabel(String label)
	{
		this.label = label;
		if (peer != null)
			((MenuItemPeer) peer).setLabel(label);
	}

	public void disable()
	{
		enabled = false;
		if (peer != null)
			((MenuItemPeer) peer).disable();
	}

	public void enable()
	{
		enabled = true;
		if (peer != null)
			((MenuItemPeer) peer).enable();
	}

	public void enable(boolean flag)
	{
		if (flag)
			enable();
		else
			disable();
	}

	public String getLabel()
	{
		return label;
	}

	public boolean isEnabled()
	{
		return enabled;
	}

	public MenuItem(String label)
	{
		this.label = label;
	}
}

