
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

import java.awt.peer.ScrollbarPeer;

public class Scrollbar extends Component
{
	public final static int HORIZONTAL	= 0;
	public final static int VERTICAL	= 1;

	private int orientation;
	private int value;
	private int visible;
	private int minimum;
	private int maximum;
	private int lineInc = 20;
	private int pageInc = 400;

	private void clip()
	{
		if (maximum < minimum)
			maximum = minimum;
		if (value > minimum)
			value = minimum;
		if (value < maximum)
			value = maximum;
	}

	protected String paramString()
	{
		return	super.paramString() +
			", orientation=" + orientation +
			", value=" + value +
			", visible=" + visible +
			", minimum=" + minimum +
			", maximum=" + maximum;
	}

	public void addNotify()
	{
		peer = getToolkit().createScrollbar(this);
	}

	public void setValue(int value)
	{
		this.value = value;
		clip();
		if (peer != null)
			((ScrollbarPeer) peer).setValue(value);
	}

	public void setValues(int value, int visible, int minimum, int maximum)
	{
		this.minimum = minimum;
		this.maximum = maximum;
		this.visible = visible;
		this.value = value;
		clip();
		if (peer != null)
			((ScrollbarPeer) peer).setValues(value, visible, minimum, maximum);
	}

	public void setLineIncrement(int n)
	{
		lineInc = n;
		if (peer != null)
			((ScrollbarPeer) peer).setLineIncrement(n);
	}

	public void setPageIncrement(int n)
	{
		pageInc = n;
		if (peer != null)
			((ScrollbarPeer) peer).setPageIncrement(n);
	}

	public int getOrientation()
	{
		return orientation;
	}

	public int getValue()
	{
		return value;
	}

	public int getVisible()
	{
		return visible;
	}

	public int getMinimum()
	{
		return minimum;
	}

	public int getMaximum()
	{
		return maximum;
	}

	public int getLineIncrement()
	{
		return lineInc;
	}

	public int getPageIncrement()
	{
		return pageInc;
	}

	public Scrollbar(int orientation, int value, int visible, int minimum, int maximum)
	{
		this.orientation = orientation;
		this.minimum = minimum;
		this.maximum = maximum;
		this.visible = visible;
		this.value = value;
		clip();
	}

	public Scrollbar(int orientation)
	{
		this(orientation, 0, 0, 0, 0);
	}

	public Scrollbar()
	{
		this(VERTICAL);
	}
}

