
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

import java.awt.peer.TextAreaPeer;

public class TextArea extends TextComponent
{
	private int rows;
	private int cols;

	protected String paramString()
	{
		return super.paramString();
	}

	public void addNotify()
	{
		peer = getToolkit().createTextArea(this);
	}

	public void appendText(String str)
	{
		int n = getText().length();
		if (peer != null)
			((TextAreaPeer) peer).insertText(text, n);
	}

	public void insertText(String str, int pos)
	{
		if (peer != null)
			((TextAreaPeer) peer).insertText(text, pos);
	}

	public void replaceText(String str, int start, int end)
	{
		if (peer != null)
			((TextAreaPeer) peer).replaceText(text, start, end);
	}

	public int getRows()
	{
		return rows;
	}

	public int getColumns()
	{
		return cols;
	}

	public Dimension minimumSize()
	{
		return	(peer != null && rows > 0 && cols > 0)
			? ((TextAreaPeer) peer).minimumSize(rows, cols)
			: super.minimumSize();
	}

	public Dimension minimumSize(int rows, int cols)
	{
		return	(peer != null)
			? ((TextAreaPeer) peer).minimumSize(rows, cols)
			: super.minimumSize();
	}

	public Dimension preferredSize()
	{
		return	(peer != null && rows > 0 && cols > 0)
			? ((TextAreaPeer) peer).preferredSize(rows, cols)
			: super.preferredSize();
	}

	public Dimension preferredSize(int rows, int cols)
	{
		return	(peer != null)
			? ((TextAreaPeer) peer).preferredSize(rows, cols)
			: super.preferredSize();
	}

	public TextArea(String text, int rows, int cols)
	{
		this.text = text;
		this.rows = rows;
		this.cols = cols;
	}

	public TextArea(int rows, int cols)
	{
		this(null, rows, cols);
	}

	public TextArea(String text)
	{
		this(text, 0, 0);
	}

	public TextArea()
	{
		this(null, 0, 0);
	}
}

