
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

import java.awt.peer.TextComponentPeer;

public class TextComponent extends Component
{
	protected String text;
	protected boolean editable = true;

	protected String paramString()
	{
		return	super.paramString() +
			(editable ? ", editable" : "");
	}

	public void removeNotify()
	{
		if (peer != null)
			peer.dispose();
		peer = null;
	}

	public void setText(String text)
	{
		if (peer != null)
			((TextComponentPeer) peer).setText(text);
	}

	public void select(int start, int end)
	{
		if (peer != null)
			((TextComponentPeer) peer).select(start, end);
	}

	public void selectAll()
	{
		int n = getText().length();
		if (peer != null)
			((TextComponentPeer) peer).select(0, n);
	}

	public void setEditable(boolean editable)
	{
		this.editable = editable;
		if (peer != null)
			((TextComponentPeer) peer).setEditable(editable);
	}

	public int getSelectionStart()
	{
		return	(peer != null)
			? ((TextComponentPeer) peer).getSelectionStart()
			: 0;
	}

	public int getSelectionEnd()
	{
		return	(peer != null)
			? ((TextComponentPeer) peer).getSelectionEnd()
			: 0;
	}

	public String getText()
	{
		return	(peer != null)
			? ((TextComponentPeer) peer).getText()
			: text;
	}

	public String getSelectedText()
	{
		String text = getText();
		return	(text != null)
			? text.substring(
				getSelectionStart(),
				getSelectionEnd()
			)
			: null;
	}

	public boolean isEditable()
	{
		return editable;
	}
}

