
// (C) 1997 Glynn Clements <glynn@sensei.co.uk> - Freely Redistributable

package java.awt;

import java.awt.peer.TextFieldPeer;

public class TextField extends TextComponent
{
	private int cols = 0;
	private char echo = '\u0000';

	protected String paramString()
	{
		return	super.paramString() +
			", cols=" + cols +
			", echo=" + echo;
	}

	public void addNotify()
	{
		peer = getToolkit().createTextField(this);
	}

	public void setEchoCharacter(char c)
	{
		echo = c;
	}

	public boolean echoCharIsSet()
	{
		return echo != '\u0000';
	}

	public char getEchoChar()
	{
		return echo;
	}

	public int getColumns()
	{
		return cols;
	}

	public Dimension minimumSize()
	{
		return	(peer != null && cols > 0)
			? ((TextFieldPeer) peer).minimumSize(cols)
			: super.minimumSize();
	}

	public Dimension minimumSize(int cols)
	{
		return	(peer != null)
			? ((TextFieldPeer) peer).minimumSize(cols)
			: super.minimumSize();
	}

	public Dimension preferredSize()
	{
		return	(peer != null && cols > 0)
			? ((TextFieldPeer) peer).preferredSize(cols)
			: super.preferredSize();
	}

	public Dimension preferredSize(int cols)
	{
		return	(peer != null)
			? ((TextFieldPeer) peer).preferredSize(cols)
			: super.preferredSize();
	}

	public TextField(String text, int cols)
	{
		this.text = text;
		this.cols = cols;
	}

	public TextField(String text)
	{
		this(text, 0);
	}

	public TextField(int cols)
	{
		this(null, cols);
	}

	public TextField()
	{
		this(null, 0);
	}
}

